(*
  CS 31600
  Hw 4
  Solutions
*)


(* Exercise 4 *)

fun min3 (x, y, z) =
  if x <= y then
    if z < x then
      z
    else
      x
  else
    if z < y then
      z
    else
      y;


fun min3v2(x, y, z) =
  if x <= y andalso x <= z then
     x
   else
     min3v2(y, z, x);


(* Exercise 5 *)

fun red3 (a, b, c) = (a, c);


(* Exercise 6 *)

fun thirds s = hd( tl( tl(explode s)));


(* Exercise 7 *)

fun cycle1 list =
  tl list @ [hd list];


(* Exercise 8 *)

fun sort3 (x : real, y, z) =
  if x <= y then
    if z < x then
      [z, x, y]
    else if y < z then
      [x, y, z]
    else
      [x, z, y]
  else
    if z < y then
      [z, y, x]
    else if x < z then
      [y, x, z]
    else
      [y, z, x];


fun sort3v2 (x : real, y, z) =
  if x <= y andalso x <= z then
    if y <= z then
      [x, y, z]
    else
      [x, z, y]
  else
    sort3v2(y,z,x);


fun sort3v3 (x : real, y, z) =
  if y < x then
    sort3v3 (y, x, z)
  else if (z < y) then
    sort3v3 (x, z, y)
  else
    [x, y, z];


(* Exercise 9 *)

fun del3 nil = nil    (* using pattern matching *)
 |  del3 (x::[]) = x::[]
 |  del3 (x::y::[]) = x::y::[]
 |  del3 (x::y::z::zs) = x::y::zs;


(* Exercise 10 *)

fun sqsum n =
  if n = 0 then
    0
  else n*n + sqsum (n-1);


(* Exercise 11 *)

fun cycle (xs, n) =
  if n = 0 then
    xs
  else
    cycle (cycle1 xs, n-1);


(* Exercise 13 *)

fun maxhelper (nil, y) = y
 |  maxhelper (x::xs, y) =
  if x > y then
    maxhelper (xs, x)
  else
    maxhelper (xs, y);

fun max x = maxhelper (tl x, hd x);


fun max_v2 (x::[]) = x
 |  max_v2 (x::xs) =
  let
    val y = max_v2 xs
  in
    if x > y then
      x
    else
      y
   end;